/*		a2html 0.4
		converts a given text-file to inline-html

		http://www.kiesler.at/article113.html
*/


		int col=0, line=1;
		int nums=1;		/* we want linenumbers in the output */
		char twochar[2]=" ";


		linenumber() {
			if(nums)
				printf("<i>%d</i>&nbsp;", line);
		}


		print(char *s) {

			if(col==0) {
				printf("<tt>");
				linenumber();
			}

			col++;

			printf("%s", s);
		}


/* html */

AMP		&
LT		<
GT		>


/* template engine */

CUROP		[\{]
CURCL		[\}]


/* bbcode */

SQOP		[\[]
SQCL		[\]]


/* white space */

SPACE		[ ]
TAB		\t
NEWLINE		\n
ANY		.


%%



{AMP}		print("&amp;");
{LT}		print("&lt;");
{GT}		print("&gt;");

{CUROP}		print("<i></i>{<i></i>");
{CURCL}		print("<i></i>}<i></i>");

{SQOP}		print("<i></i>[<i></i>");
{SQCL}		print("<i></i>]<i></i>");

{SPACE}		print("&nbsp;");


{TAB}		{	print("&nbsp;");

			while((col % 8) != 0) {
				printf("&nbsp;");
				col++;
			}
		}


{NEWLINE}	{
			if(col!=0)
				printf("</tt>");
			else
			if(nums) {
				printf("<tt>");
				linenumber("</tt>");
				printf("</tt>");
			}

			col=0; line++;
			printf("<br />\n");
		}


{ANY}		print(yytext);



%%


		main(int argc, char **argv) {
			yyin=argc>1? fopen(argv[1], "r") : stdin;

			printf("<p>");

			yylex();

			if(col!=0)
				printf("</tt>\n");

			printf("</p>");

			exit(0);
		}
